/*=========================================================================
 Authors: The GoFigure Dev. Team.
 at Megason Lab, Systems biology, Harvard Medical school, 2009-11

 Copyright (c) 2009-11, President and Fellows of Harvard College.
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
 Neither the name of the  President and Fellows of Harvard College
 nor the names of its contributors may be used to endorse or promote
 products derived from this software without specific prior written
 permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

=========================================================================*/

#ifndef __QGoPluginManager_h
#define __QGoPluginManager_h

class QGoMainWindow;
class QMenu;
class QGoPlugin;

#include <QObject>

/**
\class QGoPluginManager
\brief
*/
class QGoPluginManager:public QObject
{
  Q_OBJECT
public:
  QGoPluginManager(/*QGoMainWindow**/);
  virtual ~QGoPluginManager();

  bool IsPluginAlreadyLoaded(const QString & iName);

  void LoadPlugin(const QString &);

  void LoadPlugins();

  void ApplySettings();

  /** \brief Returns list of menus
  */
  std::list< QMenu * > GetMenus();

public slots:
  virtual void NotifyTabActivated(const int &);

  virtual void NotifyTabClosed(const int &);

  virtual void NotifyTabMoved(const int &, const int &);

protected:
  std::list< QGoPlugin * > m_PluginList;
private:
  Q_DISABLE_COPY(QGoPluginManager);
};

#endif
